{ -------------------------------------------------------------------- *
*                                                                      *
*   3333   CCCC      CCCC  OOOO  N     N  CCCC  EEEEE  PPPP  TTTTTTT   *
*       3 C         C     O    O NN    N C      E      P   P    T      *
*       3 C         C     O    O N N   N C      E      P   P    T      *
*   3333  C         C     O    O N  N  N C      EEEE   PPPP     T      *
*       3 C         C     O    O N   N N C      E      P        T      *
*       3 C         C     O    O N    NN C      E      P        T      *
*   3333   CCCC      CCCC  OOOO  N     N  CCCC  EEEEE  P        T      *
*                                                                      *
*     UNITE D'INTERFACE POUR DLL/Win32 Module TC/USB-16IO (8E/6S/1C)   *
*                                                                      *
*  (c)2012 3C CONCEPT S.A.                							   *
*	V 1.00 : 29/11/2006 : Release							           *
*   V 1.01 : 23/08/2012 : DB : Correction Fonction Close:			   *
*						  Procedure->Function						   *	 
*   V 1.02 : 05/05/2017 : JT : Ajout fonctions latch		           *
*                                                                      *
* -------------------------------------------------------------------- *
* Fichier a inclure dans le programme principal pour utiliser TCUSB16IO.DLL
* A utiliser avec la directive $INCLUDE TCUSB16IO.INC
*}

const
  maxmodule   = 8;   { N des modules de 1  8 }

{ Codes d'erreur gnrs par les fonctions de base ci-dessous,
  les fonctions oprant sur bit (BITINPUT, BITOUTPUT, BITREADBACK) ne retournent
  pas de code erreur }

  erNoError   = 0;   { OK }
  erNumSerie  = 1;   { Numero de serie incorrect }
  erModule    = 2;   { N de module incorrect }
  erNoModule  = 3;   { Pas de module TC/USB-16IO dtect }
  erNoInit    = 4;   { Module non initialis }
  erWrite     = 5;
  erRead      = 6;
  erClose     = 7;   { erreur  la fermeture }

{*************************************************************************************}
{********************** OPERATIONS DE BASE *******************************************}
{*************************************************************************************}

function TCUSB16IO_Refresh(NModule:integer):integer;stdcall;external 'TCUSB16IO.DLL';

{ Actualise les donnes (Entres + Sorties + Compteurs) du module indiqu
  A utiliser apres toute fonction sur les sorties et avant toutes fonction sur les entres et compteurs  }

{*************************************************************************************}

function TCUSB16IO_Open(NModule:integer;var NumSerie:PChar):integer;stdcall;external 'TCUSB16IO.DLL';

{ Initialise le driver, affecte le numro de srie du module au numro de module
  spcifi (1  8) et remet  0 les sorties. si numro de srie est vide alors ouvre le premier module dtect.
  A utiliser avant tout autre appel a une fonction TCUSB16IO_xxx
  Fermer la session par TCUSB16IO_Close }

{*************************************************************************************}

function TCUSB16IO_OpenN(NModule:integer;var NumSerie:DWord):integer;stdcall;external 'TCUSB16IO.DLL';

{ Initialise le driver, affecte le numro de srie du module au numro de module
  spcifi (1  8) et remet  0 les sorties. si numro de srie=0 alors ouvre le premier module dtect.
  A utiliser avant tout autre appel a une fonction TCUSB16IO_xxx
  Fermer la session par TCUSB16IO_Close }

{*************************************************************************************}

function TCUSB16IO_OpenN_InitOutput(NModule:integer;var Numserie:DWord;Data:Byte):integer;stdcall;external 'TCUSB16IO.DLL';

{ Initialise le driver, affecte le numro de srie du module au numro de module
  spcifi (1  8) et met les sorties  Data. si numro de srie=0 alors ouvre le premier module dtect.
  A utiliser avant tout autre appel a une fonction TCUSB16IO_xxx
  Fermer la session par TCUSB16IO_Close }

{*************************************************************************************}

function TCUSB16IO_Close(NModule:integer):integer;stdcall;external 'TCUSB16IO.DLL';

{ Termine la session et ferme le driver (indispensable  la fin du programme) }

{*************************************************************************************}

function TCUSB16IO_Input(NModule:integer;var Data:DWord):integer;stdcall;external 'TCUSB16IO.DLL';

{ Lecture des entres du module indiqu, le retour se fait par
  parametre dans la variable Data (32 bits), un code erreur correspond a la valeur
  retournee par la fonction }

{*************************************************************************************}

function TCUSB16IO_Output(NModule:integer;Data:Byte):integer;stdcall;external 'TCUSB16IO.DLL';

{ Envoi sur les sorties du module indiqu la valeur
  contenue dans la variable Data (8 bits), un code erreur correspond a la valeur
  retournee par la fonction }

{*************************************************************************************}
{********************** OPERATIONS SUR BITS ******************************************}
{*************************************************************************************}

function TCUSB16IO_BitInput(NModule,Entree:integer):integer;stdcall;external 'TCUSB16IO.DLL';

{ Lecture de l'tat d'une entre (1  11) du module spcifi }

{*************************************************************************************}

procedure TCUSB16IO_BitOutput(NModule,Sortie,etat:integer);stdcall;external 'TCUSB16IO.DLL';

{ Place la sortie (1  6) du module spcifie dans l'tat indiqu (0 ou 1) }

{*************************************************************************************}

function TCUSB16IO_BitReadBack(NModule,Sortie:integer):integer;stdcall;external 'TCUSB16IO.DLL';

{ Relecture de l'tat d'une sortie (1  6) du module spcifi }

{*************************************************************************************}

function TCUSB16IO_Counter(NModule,Entree:integer;var Data:byte):integer;stdcall;external 'TCUSB16IO.DLL';

{ Lecture du compteur de l'entre spcifie du module indiqu, le retour se fait par
  parametre dans la variable Data (8 bits), un code erreur correspond a la valeur
  retournee par la fonction }

{*************************************************************************************}

function TCUSB16IO_Config(NModule:integer;Data:Byte):integer;stdcall;external 'TCUSB16IO.DLL';
{ Regle  sur le module spcifi:
  1) sur les bits 1  3, la valeur du filtre numrique sur les entres Codeurs A,B,Z (0  6)
  0:24Mhz , 1:12Mhz, 2:6Mhz, 3:1.5Mhz, 4:750Khz, 5:375Khz, 6:187.5Khz
  2) La validit du TOPZ bit 4  1 ou 0
  un code erreur correspond a la valeur retournee par la fonction }

{*************************************************************************************}

function TCUSB16IO_Pos(NModule:integer;var Data:Integer):integer;stdcall;external 'TCUSB16IO.DLL';
{ Lecture du codeur du module indiqu, le retour se fait par parametre dans la variable Data (32 bits sign),
  un code erreur correspond a la valeur retournee par la fonction }

{*************************************************************************************}

function TCUSB16IO_ResetPos(NModule:integer):integer;stdcall;external 'TCUSB16IO.DLL';
{ Remise  zro du codeur du module indiqu,
  un code erreur correspond a la valeur retournee par la fonction }

{*************************************************************************************}

function TCUSB16IO_ConfigLatch(NModule:integer; Data:byte):Integer;stdcall;external 'TCUSB16IO.DLL';
{ Configure sur le module spcifi :
	1)	sur les bits 1  3 de data, le mode de latch 1 du codeur possible sur lentre 7 
	(de 0  3 avec 0:Pas de latch, 1 : Latch sur front montant de lentre 7, 
	2 : Latch sur front descendant de lentre 7, 3 : Latch sur changement dtat de lentre 7)
	2)	sur les bits 5  7 de data, le mode de latch 2 du codeur possible sur lentre 8 
	(de 0  3 avec 0:Pas de latch, 1 : Latch sur front montant de lentre 8, 
	2 : Latch sur front descendant de lentre 8, 3 : Latch sur changement dtat de lentre 8)
  Un code erreur correspond  la valeur retourne par la fonction
}

{*************************************************************************************}
function TCUSB16IO_Latch(NModule:integer;Latch:byte;var Data:Integer):integer;stdcall;external 'TCUSB16IO.DLL';
{ Lecture de la valeur du latch spcifi (de 1  2) du codeur du module spcifi. Le retour se fait par paramtre 
  dans la variable Data (32 bits signs).
  Un code erreur correspond  la valeur retourne par la fonction
}

{*************************************************************************************}

procedure TCUSB16IO_WdgRun(NModule:integer);stdcall;external 'TCUSB16IO.DLL';

{ Arme la surveillance du chien de garde sur le module spcifi }

{*************************************************************************************}

procedure TCUSB16IO_WdgStop(NModule:integer);stdcall;external 'TCUSB16IO.DLL';

{ Dsactive la surveillance du chien de garde sur le module spcifi }

{*************************************************************************************}

procedure TCUSB16IO_WdgRearm(NModule:integer);stdcall;external 'TCUSB16IO.DLL';

{ Rearmement du chien de garde sur le module spcifi }

{*************************************************************************************}

procedure TCUSB16IO_ResetPort(NModule:integer);stdcall;external 'TCUSB16IO.DLL';

{ Reinitialise le port USB du module }

{*************************************************************************************}

procedure TCUSB16IO_CyclePort(NModule:integer);stdcall;external 'TCUSB16IO.DLL';

{ Deconnecte et reconnecte le port USB du module }

{*************************************************************************************}

function TCUSB16IO_Version(NModule:integer;var Data1:Byte;var Data2:Byte):integer;stdcall;external 'TCUSB16IO.DLL';

{ Lecture de la version du firmware du module indiqu et de la DLL, le retour se fait par parametre dans les variables Data1 (module) et Data2 (DLL) (8 bits non sign),
  un code erreur correspond a la valeur retournee par la fonction }

{ Fin TCUSB16IO.INC }

